<template>
  <div class="box">
    <view-bar>Element wyposażenia</view-bar>
    <list-body class="top-list" :status="element_status">
      <h3>{{ name }}</h3>
      <span
        ><tooltip>Numer katalogowy</tooltip
        ><font-awesome-icon :icon="icons.faWrench" />{{ part_number }}</span
      >
      <span
        ><tooltip>Numer seryjny</tooltip
        ><font-awesome-icon :icon="icons.faIdCard" /> {{ serial_number }}</span
      >
      <span
        ><tooltip>Data dodania</tooltip
        ><font-awesome-icon :icon="icons.faCalendarAlt" />
        {{ creation_date }}</span
      >
      <span
        ><tooltip>Opis</tooltip><font-awesome-icon :icon="icons.faPencilAlt" />
        {{ description }}</span
      >
    </list-body>
    <h2>Historia elementu wyposażenia</h2>
    <list-body :status="list_status" :length="actions.length">
      <action-list-item
        v-for="action in actions"
        :key="action.id"
        v-bind="action"
      />
    </list-body>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";
import ViewBar from "@/components/ViewBar.vue";

import ActionListItem from "@/components/list/custom/ActionListItem.vue";
import ListBody from "@/components/list/ListBody.vue";

import { ActionData, ItemData, LocationData } from "@/interfaces";
import GenericEdit from "@/views/edit-views/GenericEdit";
import { NApi, QueryFilter } from "@/interfaces/connector";
import Tooltip from "@/components/utilities/Tooltip.vue";
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import {
  faIdCard,
  faWrench,
  faCalendarAlt,
  faPencilAlt,
} from "@fortawesome/free-solid-svg-icons";

@Options({
  props: {
    id: Number,
  },
  components: {
    ViewBar,
    ActionListItem,
    ListBody,
    Tooltip,
    FontAwesomeIcon,
  },
})
export default class EditItem
  extends GenericEdit<ActionData, ItemData>
  implements ItemData {
  public id!: number;

  LIST_API_CALL = async () =>
    await NApi.getActions(new QueryFilter().isEqual("item_id", this.id));
  ELEMENT_API_CALL = async () => await NApi.getItem(this.id);

  public name = "";
  public part_number = "";
  public serial_number = "";
  public description = "";
  public creation_date = "";

  public icons = {
    faWrench,
    faIdCard,
    faCalendarAlt,
    faPencilAlt,
  };

  public actions: ActionData[] = [];

  set_list = (list: ActionData[]) => {
    this.actions = list;
  };

  set_element = (data: ItemData) => {
    console.log(data);
    this.name = data.name;
    this.part_number = data.part_number;
    this.serial_number = data.serial_number;
    this.description = data.description as string;
    this.creation_date = data.creation_date;
  };
}
</script>

<style lang="scss" scoped>
@import "@/styles/globals";

.box {
  height: 100%;
  display: grid;

  grid-template-rows: auto auto auto 1fr;

  h3,
  span {
    position: relative;
    display: block;
    padding: 0px;
    margin: 0px;
    text-align: left;

    color: $black_text;
  }

  h3 {
    font-weight: bold;
  }

  .top-list {
    padding-top: 40px;
  }
}
</style>
